/* Sistemas Integrados TEKNISA

Nome: 9504_CVIIEO_ETL_CONTARECDTEMIS
Descrio: view que retorna AS CONTAS A RECEBER EM ABERTO POR DATA DE EMISSO DA NF (ANO E MES)

Criao:
24/07/2012 - Ftima Fernandes
*/
CREATE OR REPLACE FORCE VIEW "DM_CONTARECDTEMIS" ("CDEMPRESA", "CDFILIAL", "NMFILIALEMIT", "NMFANTCLIE", "NMRAZSOCCLIE", "NMTIPOCONTA", 
"CDANOBI", "CDMESBI", "DSDOCSERIE", "DSDESCRICAO", "DSSTCONTA", "VRBRUTOBOLETOREC", "VRLIQUIDOBOLETOREC", "VRAJUSTEBOLETOREC", "VRORIGREC",
 "VRAJUSTCTREC", "VRARECEBER", "QTCONTAS", "QTDIASVENCTO", "QTDIASATRASO", "QTBOLTEMATRASO")
AS
SELECT  BO.CDEMPRESA, BO.CDFILIAL, F.CDFILIAL || '-' || F.NMFILIAL AS NMFILIALEMIT, CL.NMFANTCLIE,
    CL.NMRAZSOCCLIE,  CT.CDTPCTRECEB || '-' || TP.DSTPCTRECEB AS NMTIPOCONTA, 
    TO_CHAR(NF.DTENTRSAID, 'YYYY') AS CDANOBI,
    TO_CHAR(NF.DTENTRSAID, 'MM') AS CDMESBI,
    (NF.NRNOTAFISC||'/'||NF.CDSERIE||' - Emisso:'||NF.DTENTRSAID) DOC_SERIE,
    (CT.DSCONTAREC) DESCRICAO,
    DECODE (NF.IDSTATUS,'V','PREVISTA','REAL') AS DSSTCONTA,
    (ROUND(BO.VRBOLREC, 2)) VRBRUTOBOLETOREC,
    (ROUND(BO.VRFINALBREC, 2)) VRLIQUIDOBOLETOREC,
    (ROUND(BO.VRFINALBREC, 2) - ROUND(BO.VRBOLREC, 2)) VRAJUSTEBOLETOREC,
    SUM(ROUND(CT.VRORIGREC, 2)) AS VRORIGREC,
    SUM(ROUND(CT.VRATUAREC,2) - ROUND(CT.VRORIGREC)) AS VRAJUSTCTREC,
    SUM(ROUND(CT.VRATUAREC, 2) + ((BO.VRFINALBREC - BO.VRBOLREC) * (CT.VRATUAREC/BO.VRBOLREC))) VRARECEBER,
    COUNT(*) AS QTCONTAS,
    (TRUNC(BO.DTVENBOLREC)  - TRUNC(NF.DTENTRSAID))  AS QTDIASVENCTO,
    (CASE WHEN TRUNC(DTVENBOLREC) < TRUNC(SYSDATE) THEN ROUND(TRUNC(SYSDATE) - TRUNC(DTVENBOLREC))  ELSE 0  END) QTDIASATRASO,
    (CASE WHEN TRUNC(DTVENBOLREC) < TRUNC(SYSDATE) THEN 1 ELSE 0 END) QTBOLTEMATRASO
    FROM CONTARECEBER CT, BOLETRECEBER BO, CLIENTE CL, TIPOCTRECEBER TP,  NOTAFISCAL NF, FILIAL F 
  WHERE BO.CDFILIAL(+)   = CT.CDFILIBOLREC
  AND BO.NRLANBOLREC(+)  = CT.NRLANBOLREC
  AND CT.IDSTATREC = 'A'
  AND CT.VRATUAREC <> 0
  AND CL.CDCLIENTE    = NF.CDCLIENTE
  AND TP.CDTPCTRECEB  = CT.CDTPCTRECEB
  AND CT.NRLANCTONF   = NF.NRLANCTONF
  AND CT.CDFILIAL     = NF.CDFILIAL
  AND NF.CDFILIEMIT   = F.CDFILIAL
  GROUP BY BO.CDEMPRESA, BO.CDFILIAL, F.CDFILIAL, F.NMFILIAL, 
  CL.NMFANTCLIE, CL.NMRAZSOCCLIE, CT.CDTPCTRECEB, TP.DSTPCTRECEB,
  BO.VRBOLREC, BO.VRFINALBREC, BO.DTVENBOLREC, NF.DTENTRSAID, NF.IDSTATUS, NF.NRNOTAFISC, NF.CDSERIE, CT.DSCONTAREC
/

BEGIN
--Fatos--
	
	CRIA_FATOS('DM_CONTARECDTEMIS', 'VRBRUTOBOLETOREC'  ,'Vrl. Bruto do Boleto'				,'Valor Bruto do Boleto'	      		,'Cont. a Rec. - Data de Emisso');
	CRIA_FATOS('DM_CONTARECDTEMIS', 'VRLIQUIDOBOLETOREC','Vrl. Lq. do Boleto'				,'Valor Lquido do Boleto'	      		,'Cont. a Rec. - Data de Emisso');
	CRIA_FATOS('DM_CONTARECDTEMIS', 'VRAJUSTEBOLETOREC'	,'Vrl. de Aj. do Bol.'				,'Valor de Ajuste Boleto'	      		,'Cont. a Rec. - Data de Emisso');
	CRIA_FATOS('DM_CONTARECDTEMIS', 'VRORIGREC'			,'Vrl. Inicial da Cont. a Receber'	,'Valor Inicial da Conta a Receber'		,'Cont. a Rec. - Data de Emisso');
	CRIA_FATOS('DM_CONTARECDTEMIS', 'VRAJUSTCTREC'		,'Vrl. de Aj. Contas a Rec.'			,'Valor de Contas a Receber'			,'Cont. a Rec. - Data de Emisso');
	CRIA_FATOS('DM_CONTARECDTEMIS', 'VRARECEBER'		,'Vrl. a Receber'					,'Valor a Receber'		      			,'Cont. a Rec. - Data de Emisso');
	CRIA_FATOS('DM_CONTARECDTEMIS', 'QTCONTAS'   		,'Quanti. de Contas'					,'Quantidade de Contas'			   		,'Cont. a Rec. - Data de Emisso');
	CRIA_FATOS('DM_CONTARECDTEMIS', 'QTDIASVENCTO'		,'Dias para o Venci.'				,'Quantidade de Dias para o venc.'    	,'Cont. a Rec. - Data de Emisso');
	CRIA_FATOS('DM_CONTARECDTEMIS', 'QTDIASATRASO'		,'Dias Atrasado'					,'Quantidade de Dias em o Atraso'     	,'Cont. a Rec. - Data de Emisso');
	CRIA_FATOS('DM_CONTARECDTEMIS', 'QTBOLTEMATRASO'    ,'Quant. de Bol. em atraso'		,'Quantidade de Boletos  em o Atraso'   ,'Cont. a Rec. - Data de Emisso');

--Dimenso
	CRIA_DIME('DM_CONTARECDTEMIS'	,'CDEMPRESA'	,'Empresa'			,'EMPRESA','CDEMPRESA'	  ,'NMEMPRESA'	  ,NULL);
	CRIA_DIME('DM_CONTARECDTEMIS'	,'CDFILIAL'		,'Filial'			,'FILIAL' ,'CDFILIAL' 	  ,'NMFILIAL' 	  ,NULL);
 CRIA_DIME('DM_CONTARECDTEMIS'	,'NMFILIALEMIT'	,'Filial de Emisso'	,NULL	  ,NULL		  ,NULL		  ,NULL);
 CRIA_DIME('DM_CONTARECDTEMIS'	,'NMFANTCLIE'	,'Nome Fantasia'		,NULL	  ,NULL		  ,NULL		  ,NULL);
 CRIA_DIME('DM_CONTARECDTEMIS'	,'NMRAZSOCCLIE'	,'Razo Social'			,NULL	  ,NULL		  ,NULL		  ,NULL);
	CRIA_DIME('DM_CONTARECDTEMIS'	,'NMTIPOCONTA'	,'Tipo de Conta'		,NULL	  ,NULL		  ,NULL		  ,NULL);
	CRIA_DIME('DM_CONTARECDTEMIS'	,'CDANOBI'		,'Ano'				,NULL	  ,NULL		  ,NULL		  ,NULL);
 CRIA_DIME('DM_CONTARECDTEMIS'	,'CDMESBI'		,'Ms'				,NULL	  ,NULL		  ,NULL		  ,NULL);
	CRIA_DIME('DM_CONTARECDTEMIS'	,'DSSTCONTA'	,'Situao da Conta'		,NULL	  ,NULL		  ,NULL		  ,NULL);
 CRIA_DIME('DM_CONTARECDTEMIS'	,'DSDOCSERIE'	,'Doc/Srie'		,NULL	  ,NULL		  ,NULL		  ,NULL);
 CRIA_DIME('DM_CONTARECDTEMIS'	,'DSDESCRICAO'	,'Descrio'		,NULL	  ,NULL		  ,NULL		  ,NULL);
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('DM_CONTARECDTEMIS','5.09.105'); END;
/